#include "Position.h"
#include "Player.h"
#include <iostream>
using namespace std;

int main() {

	// Pravilo supstitucije: Pokazivac na osnovnu klasu moze da pokazuje na objekat izvedene klase
	// Odnosno postoji implicitna konverziija Runner* -> Player*
	Player* p1 = new Player("Ivan", new Position(1, 'A'));
	Runner* r1 = new Runner("Marina", new Position(1, 'A'), 2);
	Player* p2 = new Runner("Natalija", new Position(1, 'A'), 2);

	// Zbog tog pravila mozemo u jedinstvenom nizu pokazivaca na podatke osnovne klase cuvati objekte bilo koje izvedene klase
	Player* players[] = {p1, r1, p2};

	// Pozivom neke metode koje je oznacena sa virtual preko pokazivaca osnovne klase (Clock*) pozivamo onu implementaciju metode koja odgovara pokazivanom objektu - POLIMORFIZAM
	// Implementacija metode koja se poziva se bira u trenutku izvrsavanja na osnovu tipa objekta na koji pokazuje dati pokazivac
	players[0]->move(UP);
	players[1]->move(UP);
	players[2]->move(UP);

	players[0]->getPosition()->print(); cout << endl; // 2A
	players[1]->getPosition()->print(); cout << endl; // 3A
	players[2]->getPosition()->print(); cout << endl; // 2A
	
	return 0;
}